-- Import Lotro librarys --
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";
import "Turbine.Gameplay";
import "Turbine.Gameplay.Attributes";

-- Import Globals --
import "Homeopatix.Profession.Globals";

-- Import Utility --
import "Homeopatix.Profession.Notification";
import "Homeopatix.Profession.LoadAndSave";
import "Homeopatix.Profession.MinimizedIcon";
import "Homeopatix.Profession.VindarPatch";
import "Homeopatix.Profession.FCT";

-- Import initialization --
import "Homeopatix.Profession.Init";
import "Homeopatix.Profession.Activation";

-- Import Scripts --
import "Homeopatix.Profession.Main";

-- Import UI elements --
import "Homeopatix.Profession.UI";

-- Import Commands --
import "Homeopatix.Profession.Commands";

CreateLocalizationInfo();
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CreateMainWindow();
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
ClosingTheWindow();
------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------

local player = Turbine.Gameplay.LocalPlayer.GetInstance();
local localPlayerName = player:GetName();
local playerAttr = player:GetAttributes();
local vocation = playerAttr:GetVocation();


local pathIcon = "";
if(vocation == 1) then
	pathIcon = ResourcePath .. "Explorateur.tga"
end
if(vocation == 2) then
	pathIcon = ResourcePath .. "Joaillier.tga"	
end
if(vocation == 3) then
	pathIcon = ResourcePath .. "Franc-tenancier.tga"	
end
if(vocation == 4) then
	pathIcon = ResourcePath .. "Historien.tga"	
end
if(vocation == 5) then
	pathIcon = ResourcePath .. "Fourbisseur.tga"	
end
if(vocation == 6) then
	pathIcon = ResourcePath .. "Menuisier.tga"	
end
if(vocation == 7) then
	pathIcon = ResourcePath .. "Armurier.tga"	
end

if(settings["isWindowVisible"]["isWindowVisible"] == true)then
	MainMinimizedIcon = MinimizedIcon(pathIcon, 32, 32, ProfessionWindow:SetVisible(true));
else
	MainMinimizedIcon = MinimizedIcon(pathIcon, 32, 32, ProfessionWindow:SetVisible(false));
end

MainMinimizedIcon:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings["IconPosition"]["xPosIcon"] = MainMinimizedIcon:GetLeft();
	settings["IconPosition"]["yPosIcon"] = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
ProfessionWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		if(settings["escEnable"]["escEnable"] == true) then
			ProfessionWindow:SetVisible(false);
			settings["isWindowVisible"]["isWindowVisible"] = false;
			SaveSettings();
		end
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			ProfessionWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			ProfessionWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	ProfessionWindow.PositionChanged = function( sender, args )
    	local x,y = ProfessionWindow:GetPosition();
    	settings["windowPosition"]["xPos"] = x;
    	settings["windowPosition"]["yPos"] = y;
		SaveSettings();
	end